diff --git a/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyWorldTypes.java b/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyWorldTypes.java
index a87f4c6b9..53eb26ac7 100644
--- a/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyWorldTypes.java
+++ b/game/core/src/main/java/net/minecraft/core/data/legacy/LegacyWorldTypes.java
@@ -53,7 +53,7 @@ public abstract class LegacyWorldTypes
         register(WorldTypes.OVERWORLD_RETRO, 7, "retro");
         register(WorldTypes.OVERWORLD_EXTENDED, 10, "extended");
         register(WorldTypes.NETHER_DEFAULT, 11, "nether");
-        register(WorldTypes.PARADISE_DEFAULT, 12, "paradise_"); // _ to prevent name clash
+        register(WorldTypes.DRIFT_DEFAULT, 12, "drift");
         register(WorldTypes.EMPTY, 13, "empty");
         register(WorldTypes.DEBUG, 14, "debug");
         register(WorldTypes.OVERWORLD_FLOATING, 15, "floating");
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index ba8615728..fce44bd69 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -94,6 +94,7 @@ public abstract class Mob extends Entity
     protected float flightSmoothness = 0.5f;
     private @Nullable Entity currentTarget = null;
     protected int numTicksToChaseTarget;
+    protected double jumpHeight = 0.42D;
     public @NotNull String nickname = "";
     public byte chatColor = 0;
     protected float lastStrafe = 0.0f;
@@ -890,7 +891,7 @@ public abstract class Mob extends Entity
             move(xd, yd, zd);
             if((horizontalCollision || isJumping) && canClimb())
             {
-                yd = 0.25D;
+                //yd = 0.25D;
             }
             if (!onGround){
                 movementScale = MathHelper.lerp(movementScale, 1f, pushTime);
@@ -1051,7 +1052,7 @@ public abstract class Mob extends Entity
     	if(noPhysics) {
     		return;
     	}
-        yd = 0.42D;
+        yd = jumpHeight;
         if (isSprinting())
         {
             float f = yRot * 0.01745329F;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
index 3fb849bf9..0676c72b1 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
@@ -4,6 +4,8 @@ import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.Global;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.MobFlying;
 import net.minecraft.core.entity.SkinVariantList;
@@ -26,7 +28,7 @@ import java.util.Map;
 import java.util.Set;
 import java.util.function.Supplier;
 
-public class MobButterfly extends MobFlying implements Creature {
+public class MobButterfly extends MobFlying implements AmbientCreature {
     public static final Map<Integer, ButterflyEntry> colorEntries = new HashMap<>();
 
     public static final int DATA_COLOR_ID = 16;
@@ -143,6 +145,21 @@ public class MobButterfly extends MobFlying implements Creature {
         setColor(entry.id);
     }
 
+    @Override
+    public boolean canSpawnHere()
+    {
+        if (!world.isDaytime()) return false;
+        int x = MathHelper.floor(this.x);
+        int y = MathHelper.floor(bb.minY);
+        int z = MathHelper.floor(this.z);
+        int id = world.getBlockId(x, y - 1, z);
+        if (Blocks.blocksList[id] != null)
+        {
+            return Blocks.blocksList[id].hasTag(BlockTags.PASSIVE_MOBS_SPAWN) && world.getFullBlockLightValue(x, y, z) > 8 && super.canSpawnHere();
+        }
+        return false;
+    }
+
     private boolean isCourseTraversable(double waypointX, double waypointY, double waypointZ, double distanceFromEntity)
     {
 
@@ -263,6 +280,11 @@ public class MobButterfly extends MobFlying implements Creature {
         setColor(tag.getByte("Color") & 0xFF);
     }
 
+    @Override
+    public @NotNull String getDefaultEntityTexture() {
+        return getEntityTexture();
+    }
+
     @Override
     public @NotNull String getEntityTexture() {
         return this.basePath + getTextureReference() + "_0.png";
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
index d368c873f..70dd32174 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
@@ -2,35 +2,150 @@ package net.minecraft.core.entity.animal;
 
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.entity.AgedMob;
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.MobAge;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
 import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.season.Seasons;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.List;
 
 public class MobDeer
         extends MobAnimal
         implements AgedMob
 {
     private final @NotNull MobAge age;
+    private @Nullable Entity closestThreat;
+
+    private int runawayTimer = 0;
+    private int counter = 0;
+    private boolean isRunningAway = false;
+
+    private final int MAX_RUNAWAY_TIME = 200;
+    private final int COUNTER_TIME = 30;
 
     public MobDeer(World world)
     {
         super(world);
         setTextureIdentifier("minecraft", "deer");
         setSize(0.9F, 1.3F);
+        moveSpeed = 0.8F;
         mobDrops.add(new WeightedRandomLootObject(Items.FOOD_VENISON_RAW.getDefaultStack(), 1, 2));
         this.age = MobAge.newRandom(this, MobAge.YEAR_LENGTH_DAYS * 5, 14, MobAge.YEAR_LENGTH_DAYS * 4);
+        this.jumpHeight = 0.5D;
     }
 
     @Override
     public void onLivingUpdate() {
         super.onLivingUpdate();
-
         this.getMobAge().tick(this.world);
     }
 
+    @Override
+    public boolean hurt(@Nullable Entity attacker, int damage, DamageType type)
+    {
+        if (attacker != null) {
+            beginRunaway();
+        }
+
+        return super.hurt(attacker, damage, type);
+    }
+
+    private void beginRunaway() {
+        runawayTimer = MAX_RUNAWAY_TIME;
+        counter = COUNTER_TIME;
+        moveSpeed = 2.5F;
+        findRandomPathToRunTo();
+    }
+
+    private void stopRunaway() {
+        isRunningAway = false;
+        this.counter = 0;
+        moveSpeed = 0.4F;
+    }
+
+    @Override
+    protected void updateAI()
+    {
+        super.updateAI();
+
+        if(runawayTimer <= 0) {
+            findThreatNearby();
+            if (this.closestThreat != null)
+                beginRunaway();
+            else if(isRunningAway)
+                stopRunaway();
+        } else {
+            //this.isJumping = true;
+            isRunningAway = true;
+            if(counter >= 0) {
+                counter--;
+            } else {
+                findRandomPathToRunTo();
+                counter = COUNTER_TIME;
+            }
+            runawayTimer--;
+
+        }
+
+        if(isRunningAway && onGround && !isJumping && isWalking) {
+            // hop along the ground when scared
+                yd = 0.35d;
+                float f = yRot * 0.01745329F;
+                xd -= MathHelper.sin(f) * 0.25F;
+                zd += MathHelper.cos(f) * 0.25F;
+
+        }
+
+    }
+
+    protected void findThreatNearby() {
+        int dist = 10;
+        Player player = world.getClosestPlayer(x, y, z, dist);
+        if(player != null && !player.isSneaking()){
+            this.closestThreat = player;
+            return;
+        }
+
+        if(player == null){
+            List<MobWolf> nearbyWolves = world.getEntitiesWithinAABB(MobWolf.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(8D, 4D, 8D));
+            if (!nearbyWolves.isEmpty()) {
+                this.closestThreat = nearbyWolves.get(random.nextInt(nearbyWolves.size()));
+                return;
+            }
+        }
+        this.closestThreat = null;
+    }
+
+    private void findRandomPathToRunTo() {
+        if (this.closestThreat != null)
+            getPathAwayFromPoint(this.x + random.nextInt(8)-4, this.z + random.nextInt(8)-4, closestThreat.x, closestThreat.z);
+        else
+            getPathAwayFromPoint(this.x, this.z, this.x + random.nextInt(8)-4, this.z + random.nextInt(8)-4);
+    }
+
+    protected void getPathAwayFromPoint(double x, double z, double pX, double pZ) {
+        int scale = 10;
+        double dX = x - pX;
+        double dZ = z - pZ;
+
+        double sqrt = Math.sqrt(dX * dX + dZ * dZ);
+
+        double nDX = dX / sqrt;
+        double nDZ = dZ / sqrt;
+
+        Vec3 safePoint = Vec3.getTempVec3(x + nDX * scale, y, z + nDZ * scale);
+        pathToEntity = world.getEntityPathToXYZ(this, MathHelper.floor(safePoint.x), MathHelper.floor(y), MathHelper.floor(safePoint.z), 16F);
+    }
+
     @Override
     public @NotNull MobAge getMobAge() {
         return this.age;
@@ -40,7 +155,7 @@ public class MobDeer
     public void addAdditionalSaveData(@NotNull CompoundTag tag)
     {
         super.addAdditionalSaveData(tag);
-
+        tag.putShort("RunawayTimer", (short) runawayTimer);
         this.age.writeTag(tag);
     }
 
@@ -56,7 +171,7 @@ public class MobDeer
     public void readAdditionalSaveData(@NotNull CompoundTag tag)
     {
         super.readAdditionalSaveData(tag);
-
+        this.runawayTimer = tag.getShort("RunawayTimer");
         this.age.readTag(tag);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
index bb3d06526..a2f44f0f9 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
@@ -453,7 +453,7 @@ public class MobFireflyCluster extends MobFlying
 				Biomes.OVERWORLD_TUNDRA,
 				Biomes.OVERWORLD_BOREAL_FOREST,
 				Biomes.OVERWORLD_GLACIER,
-				Biomes.PARADISE_PARADISE
+				Biomes.DRIFT_DRIFT
 		},
 				new float[]{0.67f, 1f, 0.99f}));
 		public static FireflyColor RED = register(new FireflyColor(3, "fireflyRed", new Biome[] {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWaterAnimal.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWaterAnimal.java
index 7eebfcfbf..f40415e21 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWaterAnimal.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWaterAnimal.java
@@ -6,7 +6,7 @@ import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
 public class MobWaterAnimal extends MobPathfinder
-	implements Creature
+	implements WaterCreature
 {
 
     public MobWaterAnimal(World world)
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index eeda93f1a..557c8ca65 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -341,10 +341,18 @@ public class MobWolf
         } else
         if(getTarget() == null && !hasPath())
         {
-            if(!isWolfTamed() && world.rand.nextInt(100) == 0){
-                List<MobSheep> nearbySheep = world.getEntitiesWithinAABB(MobSheep.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
-                if (!nearbySheep.isEmpty()) {
-                    setTarget(nearbySheep.get(world.rand.nextInt(nearbySheep.size())));
+            if(!isWolfTamed() && world.rand.nextInt(50) == 0){
+                List<MobAnimal> validTargets = new ArrayList<>();
+                List<MobAnimal> nearbyAnimals = world.getEntitiesWithinAABB(MobAnimal.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
+                if (!nearbyAnimals.isEmpty()) {
+                    for(int i = 0; i < nearbyAnimals.size(); i++){
+                        MobAnimal animal = nearbyAnimals.get(i);
+                        if(animal instanceof MobSheep || animal instanceof MobDeer)
+                            validTargets.add(animal);
+                    }
+                }
+                if (!validTargets.isEmpty()) {
+                    setTarget(validTargets.get(world.rand.nextInt(validTargets.size())));
                 }
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/WaterCreature.java b/game/core/src/main/java/net/minecraft/core/entity/animal/WaterCreature.java
new file mode 100644
index 000000000..5378b9e0e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/WaterCreature.java
@@ -0,0 +1,4 @@
+package net.minecraft.core.entity.animal;
+
+public interface WaterCreature {
+}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/Enemy.java b/game/core/src/main/java/net/minecraft/core/entity/monster/Enemy.java
index a644bf256..70e5cf70c 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/Enemy.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/Enemy.java
@@ -1,9 +1,6 @@
 package net.minecraft.core.entity.monster;
 
 
-import net.minecraft.core.entity.animal.Creature;
-
 public interface Enemy
-	extends Creature
 {
 }
diff --git a/game/core/src/main/java/net/minecraft/core/enums/MobCategory.java b/game/core/src/main/java/net/minecraft/core/enums/MobCategory.java
index f51929a83..e655f22b3 100644
--- a/game/core/src/main/java/net/minecraft/core/enums/MobCategory.java
+++ b/game/core/src/main/java/net/minecraft/core/enums/MobCategory.java
@@ -2,16 +2,18 @@ package net.minecraft.core.enums;
 
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.animal.AmbientCreature;
+import net.minecraft.core.entity.animal.Creature;
 import net.minecraft.core.entity.animal.MobAnimal;
 import net.minecraft.core.entity.animal.MobWaterAnimal;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.animal.WaterCreature;
 import net.minecraft.core.entity.monster.Enemy;
 
 public enum MobCategory {
 
 	monster("monster", 0, Enemy.class, 70, Material.air, false),
-    creature("creature", 1, MobAnimal.class, 15, Material.air, true),
-    waterCreature("waterCreature", 2, MobWaterAnimal.class, 5, Material.water, true),
+    creature("creature", 1, Creature.class, 15, Material.air, true),
+    waterCreature("waterCreature", 2, WaterCreature.class, 5, Material.water, true),
     ambientCreature("ambient", 3, AmbientCreature.class, 2, Material.air, true);
 	
 	private final Class<?> baseClass;
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeSeason.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeSeason.java
index 8d2805996..44aef888a 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeSeason.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeSeason.java
@@ -19,7 +19,7 @@ import java.util.List;
 import java.util.concurrent.CompletableFuture;
 
 public class ArgumentTypeSeason implements ArgumentType<String> {
-    private static final List<String> EXAMPLES = Arrays.asList("overworld.winter", "overworld.summer", "paradise.gold");
+    private static final List<String> EXAMPLES = Arrays.asList("overworld.winter", "overworld.summer", "drift.gold");
 
     public static ArgumentType<String> season() {
         return new ArgumentTypeSeason();
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryAnimal.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryAnimal.java
index 45bc7d06b..2e2567967 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryAnimal.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryAnimal.java
@@ -10,10 +10,11 @@ import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketAddMob;
 import org.jetbrains.annotations.NotNull;
 
-public class NetEntryAnimal<T extends Creature> implements IPacketEntry<T>, ITrackedEntry<T> {
+public class NetEntryAnimal<T extends Mob> implements IPacketEntry<T>, ITrackedEntry<T> {
+    @SuppressWarnings("unchecked")
     @Override
     public @NotNull Class<T> getAppliedClass() {
-        return (Class<T>) Creature.class;
+        return (Class<T>) Mob.class;
     }
 
     @Override
@@ -32,12 +33,12 @@ public class NetEntryAnimal<T extends Creature> implements IPacketEntry<T>, ITra
     }
 
     @Override
-    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, Creature trackedObject) {
+    public void onEntityTracked(EntityTracker tracker, EntityTrackerEntry trackerEntry, Mob trackedObject) {
 
     }
 
     @Override
-    public Packet getSpawnPacket(EntityTrackerEntry tracker, Creature trackedObject) {
-        return new PacketAddMob((Mob) trackedObject);
+    public Packet getSpawnPacket(EntityTrackerEntry tracker, Mob trackedObject) {
+        return new PacketAddMob(trackedObject);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/Dimension.java b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
index 22450e328..b33eab778 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Dimension.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
@@ -79,7 +79,7 @@ public class Dimension
 
 	public static final Dimension OVERWORLD = new Dimension("overworld", null, 1.0f, null, WorldTypes.OVERWORLD_DEFAULT);
 	public static final Dimension NETHER = new Dimension("nether", OVERWORLD, 0.125f, Blocks.PORTAL_NETHER, WorldTypes.NETHER_DEFAULT);
-	public static final Dimension PARADISE = new Dimension("paradise", OVERWORLD, 8.0f, Blocks.PORTAL_PARADISE, WorldTypes.PARADISE_DEFAULT);
+	public static final Dimension DRIFT = new Dimension("drift", OVERWORLD, 8.0f, Blocks.PORTAL_DRIFT, WorldTypes.DRIFT_DEFAULT);
 
 	public static Map<Integer, Dimension> getDimensionList()
 	{
@@ -100,6 +100,6 @@ public class Dimension
 	public static void init(){
 		registerDimension(0, OVERWORLD);
 		registerDimension(1, NETHER);
-		registerDimension(2, PARADISE);
+		registerDimension(2, DRIFT);
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
index 2b9e3f455..821817428 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biome.java
@@ -56,6 +56,7 @@ public class Biome
         spawnableCreatureList.add(new SpawnListEntry(MobDeer.class, 10));
         spawnableWaterCreatureList.add(new SpawnListEntry(MobSquid.class, 10));
         spawnableAmbientCreatureList.add(new SpawnListEntry(MobFireflyCluster.class, 10));
+        spawnableAmbientCreatureList.add(new SpawnListEntry(MobButterfly.class, 65));
     }
 
     public WorldFeature getRandomWorldGenForTrees(Random random)
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
index bf5205f60..9e2c8d5b2 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/Biomes.java
@@ -4,7 +4,8 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.world.biome.nether.*;
 import net.minecraft.core.world.biome.overworld.*;
-import net.minecraft.core.world.biome.paradise.BiomeParadise;
+import net.minecraft.core.world.biome.drift.BiomeDrift;
+import net.minecraft.core.world.biome.overworld.legacy.*;
 import net.minecraft.core.world.weather.Weathers;
 
 public class Biomes
@@ -24,7 +25,7 @@ public class Biomes
     public static final Biome OVERWORLD_GLACIER = register("minecraft:overworld.glacier", new Biome("overworld.glacier").setColor(0xcbf6ff).setSurfaceSnow().setTopBlock(Blocks.BLOCK_SNOW.id()).setFillerBlock(Blocks.BLOCK_SNOW.id()));
     public static final Biome OVERWORLD_TUNDRA = register("minecraft:overworld.tundra", new Biome("overworld.tundra").setColor(0x57e0ff).setSurfaceSnow());
     public static final Biome OVERWORLD_MEADOW = register("minecraft:overworld.meadow", new BiomeBorealForest("overworld.meadow").setColor(0x8c8c22));
-    public static final Biome PARADISE_PARADISE = register("minecraft:paradise.paradise", new BiomeParadise("overworld.paradise").setColor(0x8080FF).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG));
+    public static final Biome DRIFT_DRIFT = register("minecraft:drift.drift", new BiomeDrift("drift.drift").setColor(0x8080FF).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG));
     public static final Biome OVERWORLD_BIRCH_FOREST = register("minecraft:overworld.birch_forest", new BiomeBirchForest("overworld.birch_forest").setColor(0x4bcb5e));
     public static final Biome OVERWORLD_RETRO = register("minecraft:overworld.retro", new BiomeRetro("overworld.retro").setColor(0x76B14A).setTopBlock(Blocks.GRASS_RETRO.id()));
     public static final Biome OVERWORLD_HELL = register("minecraft:overworld.hell", new Biome("overworld.hell").setColor(0xD96223).setTopBlock(Blocks.DIRT_SCORCHED.id()).setTopBlock(Blocks.DIRT_SCORCHED.id()));
@@ -39,6 +40,17 @@ public class Biomes
     public static final Biome NETHER_ASH_PLAINS = register("minecraft:nether.ash_plains", new BiomeAshPlains("nether.ash_plains").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.SLATE.id()).setFillerBlock(Blocks.SLATE.id()));
     public static final Biome NETHER_BONEYARD = register("minecraft:nether.boneyard", new BiomeBoneyard("nether.boneyard").setColor(0xDD0000).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM, Weathers.OVERWORLD_FOG).setTopBlock(Blocks.SOULSAND.id()).setFillerBlock(Blocks.SOULSAND.id()));
 
+    public static final Biome OVERWORLD_LEGACY_RAINFOREST = register("minecraft:overworld.legacy.rainforest", new BiomeRainforestLegacy("overworld.legacy.rainforest").setColor(0xd9e023).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
+    public static final Biome OVERWORLD_LEGACY_SWAMPLAND = register("minecraft:overworld.legacy.swampland", new BiomeSwampLegacy("overworld.legacy.swampland").setColor(0x07f9b2));
+    public static final Biome OVERWORLD_LEGACY_SEASONAL_FOREST = register("minecraft:overworld.legacy.seasonal_forest", new Biome("overworld.legacy.seasonal_forest").setColor(0x9be023));
+    public static final Biome OVERWORLD_LEGACY_FOREST = register("minecraft:overworld.legacy.forest", new BiomeForestLegacy("overworld.legacy.forest").setColor(0x056621));
+    public static final Biome OVERWORLD_LEGACY_SAVANNA = register("minecraft:overworld.legacy.savanna", new BiomeDesertLegacy("overworld.legacy.savanna").setColor(0xd9e023).setBlockedWeathers(Weathers.OVERWORLD_SNOW));
+    public static final Biome OVERWORLD_LEGACY_SHRUBLAND = register("minecraft:overworld.legacy.shrubland", new Biome("overworld.legacy.shrubland").setColor(0xa1ad20));
+    public static final Biome OVERWORLD_LEGACY_TAIGA = register("minecraft:overworld.legacy.taiga", new BiomeTaigaLegacy("overworld.legacy.taiga").setColor(0x2eb153).setSurfaceSnow());
+    public static final Biome OVERWORLD_LEGACY_DESERT = register("minecraft:overworld.legacy.desert", new BiomeDesertLegacy("overworld.legacy.desert").setColor(0xfa9418).setBlockedWeathers(Weathers.OVERWORLD_RAIN, Weathers.OVERWORLD_SNOW, Weathers.OVERWORLD_STORM).setTopBlock(Blocks.SAND.id()).setFillerBlock(Blocks.SAND.id()));
+    public static final Biome OVERWORLD_LEGACY_PLAINS = register("minecraft:overworld.legacy.plains", new BiomeDesertLegacy("overworld.legacy.plains").setColor(0xffd910));
+    public static final Biome OVERWORLD_LEGACY_TUNDRA = register("minecraft:overworld.legacy.tundra", new Biome("overworld.legacy.tundra").setColor(0x57ebf9).setSurfaceSnow());
+
     public static Biome register(String key, Biome biome)
     {
         Registries.BIOMES.register(key, biome);
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/paradise/BiomeParadise.java b/game/core/src/main/java/net/minecraft/core/world/biome/drift/BiomeDrift.java
similarity index 78%
rename from game/core/src/main/java/net/minecraft/core/world/biome/paradise/BiomeParadise.java
rename to game/core/src/main/java/net/minecraft/core/world/biome/drift/BiomeDrift.java
index dbd136566..b3f0cc0f3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/biome/paradise/BiomeParadise.java
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/drift/BiomeDrift.java
@@ -1,12 +1,12 @@
-package net.minecraft.core.world.biome.paradise;
+package net.minecraft.core.world.biome.drift;
 
 import net.minecraft.core.entity.animal.MobChicken;
 import net.minecraft.core.entity.SpawnListEntry;
 import net.minecraft.core.world.biome.Biome;
 
-public class BiomeParadise extends Biome
+public class BiomeDrift extends Biome
 {	
-    public BiomeParadise(String key)
+    public BiomeDrift(String key)
     {
     	super(key);
         spawnableMonsterList.clear();
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeDesertLegacy.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeDesertLegacy.java
new file mode 100644
index 000000000..fdcae4926
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeDesertLegacy.java
@@ -0,0 +1,11 @@
+package net.minecraft.core.world.biome.overworld.legacy;
+
+import net.minecraft.core.world.biome.Biome;
+
+public class BiomeDesertLegacy
+    extends Biome
+{
+    public BiomeDesertLegacy(final String key) {
+        super(key);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeForestLegacy.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeForestLegacy.java
new file mode 100644
index 000000000..66d2bd8cc
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeForestLegacy.java
@@ -0,0 +1,29 @@
+package net.minecraft.core.world.biome.overworld.legacy;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.entity.animal.MobWolf;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
+
+import java.util.Random;
+
+public class BiomeForestLegacy
+    extends Biome
+{
+    public BiomeForestLegacy(final String key) {
+        super(key);
+        spawnableCreatureList.add(new SpawnListEntry(MobWolf.class, 2));
+    }
+
+    @Override
+    public WorldFeature getRandomWorldGenForTrees(final Random random) {
+        if (random.nextInt(5) == 0) {
+            return new WorldFeatureTree(Blocks.LEAVES_BIRCH.id(), Blocks.LOG_BIRCH.id(), 5);
+        } else {
+            return (random.nextInt(3) == 0) ? new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id()) : new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 4);
+        }
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeRainforestLegacy.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeRainforestLegacy.java
new file mode 100644
index 000000000..3faa48598
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeRainforestLegacy.java
@@ -0,0 +1,22 @@
+package net.minecraft.core.world.biome.overworld.legacy;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTree;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
+
+import java.util.Random;
+
+public class BiomeRainforestLegacy
+    extends Biome
+{
+    public BiomeRainforestLegacy(final String key) {
+        super(key);
+    }
+
+    @Override
+    public WorldFeature getRandomWorldGenForTrees(final Random random) {
+        return (random.nextInt(3) == 0) ? new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id()) : new WorldFeatureTree(Blocks.LEAVES_OAK.id(), Blocks.LOG_OAK.id(), 4);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeSwampLegacy.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeSwampLegacy.java
new file mode 100644
index 000000000..84f550c2c
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeSwampLegacy.java
@@ -0,0 +1,11 @@
+package net.minecraft.core.world.biome.overworld.legacy;
+
+import net.minecraft.core.world.biome.Biome;
+
+public class BiomeSwampLegacy
+    extends Biome
+{
+    public BiomeSwampLegacy(final String key) {
+        super(key);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeTaigaLegacy.java b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeTaigaLegacy.java
new file mode 100644
index 000000000..48842c748
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/biome/overworld/legacy/BiomeTaigaLegacy.java
@@ -0,0 +1,28 @@
+package net.minecraft.core.world.biome.overworld.legacy;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTaigaBushy;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeTaigaTall;
+
+import java.util.Random;
+
+public class BiomeTaigaLegacy
+    extends Biome
+{
+    public BiomeTaigaLegacy(final String key) {
+        super(key);
+    }
+
+    @Override
+    public WorldFeature getRandomWorldGenForTrees(final Random random) {
+        if(random.nextInt(3) == 0)
+        {
+            return new WorldFeatureTreeTaigaTall(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
+        } else
+        {
+            return new WorldFeatureTreeTaigaBushy(Blocks.LEAVES_PINE.id(), Blocks.LOG_PINE.id());
+        }
+    }
+}
